﻿using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace AutoSizeEmbeddedUserControl
{
    public partial class Form1 : Form
    {
        CustomEditor userEditor = new CustomEditor();
        object test = null;
        public Form1()
        {
            InitializeComponent();
            ultraGrid1.BeforeCellActivate += ultraGrid1_BeforeCellActivate;
            ultraGrid1.BeforeCellDeactivate += ultraGrid1_BeforeCellDeactivate;
          
        }

        void ultraGrid1_BeforeCellDeactivate(object sender, CancelEventArgs e)
        {
           //Update the cell with the changes made to the user control. 
        }

        void ultraGrid1_BeforeCellActivate(object sender, CancelableCellEventArgs e)
        {
            var editor = userEditor.Controls[1];
           // test = editor.Text;
            editor.Text = e.Cell.Value.ToString();
            UltraGrid grid = (UltraGrid)sender;
            UIElement element = e.Cell.GetUIElement();
            if (element != null)
            {
                Point p = new Point(element.Rect.Left, element.Rect.Top);
                p = grid.PointToScreen(p);
                ultraPopupControlContainer1.PopupControl = userEditor;                
                this.ultraPopupControlContainer1.Show(grid, p);
                test = e.Cell.Value;
            }            
        }

        private void ultraGrid1_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
        {
            e.Row.Height = userEditor.Height;
            
            e.Row.PerformAutoSize();

            
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
           
            ultraControlContainerEditor1.EditingControl = userEditor.TopLevelControl;

           e.Layout.Bands[0].Columns[0].EditorComponent = ultraControlContainerEditor1;           
        }
    }
}
